SystemOrganization addCategory: #Ajedrez!

SimpleSwitchMorph subclass: #GPixel
	instanceVariableNames: 'sizePixel mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!GPixel methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 09:59'!
colorOn
	"Cambia el color del pixel a negro"

	self color: Color black  ! !

!GPixel methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 10:24'!
getSizePixel 
	"Returna el tamao del pixel"

	^sizePixel ! !

!GPixel methodsFor: 'initialization' stamp: 'yusenmanchego 10/13/2012 14:42'!
initialize 
	"Iniciamos la clase GPixel, creando un pixel como un cuadrado de tamao sizePixel y color blanco"

	super  initialize .
	sizePixel := 5 .
	bounds := (0@0) corner: (sizePixel@sizePixel).
	fullBounds := (0@0) corner: (sizePixel@sizePixel).
	color := Color white .
	borderWidth := 0.
	label := ''.
	self useSquareCorners .
	
	
! !

!GPixel methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 14:02'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!GPixel methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 10:19'!
setSizePixel: newSize
	"cambia el tamao del cuadrado que representa el pixel"

	sizePixel := newSize ! !

Object subclass: #Picture
	instanceVariableNames: 'matrix ancho altura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!Picture class methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 13:56'!
caballo
	"Retorna una matrix de un caballo"
	
	| caballo |
	caballo := #(
		'                                                           '
	  	'                                                           '
       	'                                                           ' 
        	'                                                           '
        	'                                                           '
        	'               #         ##                                ' 
        	'              ###       ####                               ' 
        	'              #####     ####                               ' 
        	'               #####   ######                              ' 
        	'               ## ### ###  ##                              ' 
        	'               ##  #####   ######                          ' 
        	'               ##   ####   #########                       ' 
        	'               ##  #####   ##   ######                     ' 
        	'              ### ###       #     ######                   ' 
        	'             ###  #                 #####                  ' 
        	'            ###                       ####                 ' 
        	'            ##                         ####                ' 
        	'           ###  ####                    ####               ' 
        	'           ##  ####                      ####              ' 
        	'           ##  ####                      #####             ' 
        	'           ##  ###                        ####             ' 
        	'	          ###  #              ##           ####            ' 
        	'          ##                  ##           ####            ' 
        	'          ##                  ##            ####           ' 
        	'         ###                  ##            ####           ' 
        	'         ##                   ##             ####          ' 
        	'        ###                  ###             ####          ' 
        	'       ###                  ###              ####          ' 
        	'      ###                   ###               ####         ' 
        	'      ##                   ####               ####         ' 
        	'     ###                 ######               ####         ' 
        	'     ##                ####  ##                ####        ' 
        	'    ### ##           ####    ##                ####        ' 
        	'    ## ###         ####     ###                ####        ' 
        	'    ## ###        ###       ##                 ####        ' 
        	'    ## ##        ###       ###                 #####       ' 
        	'    ##      ##  ###        ##                   ####       ' 
        	'    ##     ### ###        ###                   ####       ' 
        	'    ###   #######        ###                    ####       ' 
        	'     ######## ##        ###                     ####       ' 
        	'       #########       ###                      ####       ' 
        	'            ###       ###                       #####      ' 
        	'                     ###                        #####      ' 
        	'                    ###                          ####      ' 
        	'                    ##                           ####      ' 
        	'                   ###                           ####      ' 
        	'                  ###                            ####      ' 
        	'                  ##                             ####      ' 
        	'                 ###                             ####      ' 
        	'                 ##                              ####      ' 
        	'                 ##                              ####      ' 
        	'                 ####################################      ' 
        	'                 ####################################      ' 
        	'                                                           ' 
        	'                                                           ' 
        	'                                                           ' 
        	'                                                           ' 
        	'                                                           '
	).	
	^caballo
! !

!Picture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 12:21'!
initialize
	"Crea una matriz que representara una imagen con dimensiones especificadas por wh"
	
	super initialize .
	

	
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 12:32'!
setMatrix: newMatrix
	"Recibe la matrix que contiene los datos de la imagen a"
	
	matrix := newMatrix 
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 12:26'!
sizeMatrix: wh
	"Inicializa la matrix con espacios en blanco"

	|defaultString|
	ancho := wh x.
	altura := wh y.
	matrix := Array new: altura .
	
	defaultString  := String new: ancho .
	1 to: ancho do: [ : i | defaultString at: i put: (Character value: 32) ].
	
	1 to: altura do: [ :j | matrix at: j put: defaultString ].! !

BorderedMorph subclass: #GPicture
	instanceVariableNames: 'pixeles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!GPicture methodsFor: 'initialization' stamp: 'yusenmanchego 10/13/2012 13:03'!
initialize 
	"Inicializa la clase GPicture, creando una espacio para visualizar imagen"
	
	super initialize.


	
	
	! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 13:24'!
nuevoPixelX: i Y: j 
	"comment stating purpose of message"

	| pix origen|
	pix := GPixel new.
	origen := self innerBounds origin.
	self addMorph: pix.
	
	pix position: ((i - 1) * pix width) @ ((j - 1) * pix height) + origen.
	pix mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^pix
	! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'yusenmanchego 10/13/2012 14:34'!
visualizar: picture
	"Muestra la imagen que le demos"
	| ancho altura pixel pSize|
	pixel := GPixel new.
	pSize := pixel getSizePixel .
	ancho  := picture size .	
	altura := (picture at:1) size .

	self bounds: (5@5 extent: ( (ancho*pSize)@(altura*pSize) )+(2 * self borderWidth)).
	pixeles :=Matrix rows: ancho  columns: altura tabulate: [ :i :j | self nuevoPixelX: i Y: j ].
	
	1 to: ancho do: [
		:i |  |cad| cad:=picture at: i.
		1 to: altura do: [
			:j | ($# =(cad at:j) ) ifTrue: [ (pixeles  at: i at: j ) colorOn ]
			]
		]! !
